<template>
  <div id="app">
    <div class="center">
      <button class="btn btn-outline-primary" @click="changeShowAddUser">{{ $t('add-account') }}</button>
    </div>
    <div v-show=showAddUser>
        <div class="form" :style="customColorStyle">
          <div class="form-group">
            <label>{{ $t('user') }} *</label>
            <input v-model="userToAdd.mail" class="form-control" :placeholder="$t('user')">
          </div>
          <div class="form-group">
            <label>{{ $t('pw') }}*</label>
            <input v-model="userToAdd.pw" class="form-control" :placeholder="$t('pw')">
          </div>
          <div class="form-group">
            <label>{{ $t('role') }} *</label>
            <div>
                <multiselect
                  :multiple="true"
                  :searchable="true"
                  :close-on-select="false"
                  :clear-on-select="false"
                  v-model="userToAdd.rolesStr"
                  :options="optionsRoles"
                />
            </div>
          </div>
          <div class="center">
            <button v-show="!isUpdate" @click="addUser" class="btn btn-outline-success">{{ $t('add') }}</button>
            <button v-show="isUpdate" @click="updateUser" class="btn btn-outline-success">{{ $t('update') }}</button>
            <button @click="resetUser" class="btn btn-outline-secondary">{{ $t('reset') }}</button>
          </div>
        </div>
      </div>
    <div class="center">
      <table class="table table-hover">
        <thead>
          <tr>
            <th scope="col"></th>
            <th scope="col">{{ $t('role') }}</th>
            <th scope="col">{{ $t('edit') }}</th>
            <th scope="col">{{ $t('delete') }}</th>
          </tr>
        </thead>
        <tbody>
          <tr :style="customBgColor">
            <td> {{ mainUser.mail }} <span> ({{ $t('it-is-you') }}) </span> </td>
            <td>{{ roleTabToStr(mainUser.roles) }}</td>
            <td><button @click="editUser(mainUser)" class="btn btn-outline-warning"> <font-awesome-icon icon="edit"/> </button></td>
            <td><button @click="deleteUser(mainUser)" class="btn btn-outline-danger"> <font-awesome-icon icon="trash-alt"/> </button></td>
          </tr>
          <tr v-bind:key="user.id" v-for="user in getAllUsersWithoutCurrent" v-bind:value="user">
            <td> {{ user.mail }} </td>
            <td>{{ roleTabToStr(user.roles) }}</td>
            <td><button @click="editUser(user)" class="btn btn-outline-warning"> <font-awesome-icon icon="edit"/> </button></td>
            <td><button @click="deleteUser(user)" class="btn btn-outline-danger"> <font-awesome-icon icon="trash-alt"/> </button></td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
import custom from '@/shared/custom'
import APIUser from '@/api/user'
import APIRole from '@/api/role'
import Multiselect from 'vue-multiselect'
export default {
  components: {
    Multiselect
  },
  data () {
    return {
      isUpdate: false,
      roles: null,
      optionsRoles: [],
      users: [],
      showAddUser: false,
      mainUser: { roles: [] },
      userToAdd: {
        id: null,
        mail: null,
        pw: null,
        roles: [],
        rolesStr: []
      }
    }
  },
  methods: {
    roleTabToStr (roles) {
      let res = ''
      roles.forEach(role => {
        res += role.libelle + ', '
      })
      return res.substr(0, res.length - 2)
    },
    changeShowAddUser () {
      this.showAddUser = !this.showAddUser
    },
    editUser (user) {
      this.userToAdd = user
      this.showAddUser = true
      this.isUpdate = true
    },
    getGoodMessage (user) {
      return this.ifCurrentUser(user) ? this.$t('need-reconnect') + ' ' + this.$t('to-show-modif') : this.$t('delete-user-success')
    },
    ifCurrentUser (user) {
      return user.id === this.mainUser.id
    },
    resetUser () {
      this.userToAdd = {
        id: null,
        mail: null,
        pw: null,
        rolesStr: [],
        roles: []
      }
      this.isUpdate = false
    },
    deleteUser (user) {
      this.$store.commit('saveLoading', true)
      APIUser.deleteUser(user).then(res => {
        this.$alert(this.getGoodMessage(user), this.$t('success'), 'success')
        const indexOfUserToDelete = this.users.indexOf(user)
        // delete user from array
        this.users = this.users.slice(0, indexOfUserToDelete).concat(this.users.slice(indexOfUserToDelete + 1))
        this.$store.commit('saveLoading', false)
      }).catch(() => {
        this.$store.commit('saveLoading', false)
        this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
      })
    },
    getRoleObjectFromRoleStr (roleStr) {
      var res = null
      this.roles.forEach(role => {
        if (role.libelle === roleStr) {
          res = role
          return res
        }
      })
      return res
    },
    addUser () {
      if (this.checkUser() === 'KO') {
        return -1
      }
      APIUser.createUser(this.userToAdd).then(user => {
        // console.log(user)
        this.$store.commit('saveLoading', false)
        if (!this.userToAdd.id) {
          this.users.push(user)
        }
        this.$alert(this.getGoodMessage(user), this.$t('success'), 'success')
      }).catch((error) => {
        console.log(error)
        this.$store.commit('saveLoading', false)
        this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
      })
    },
    updateUser () {
      if (this.checkUser() === 'KO') {
        return -1
      }
      APIUser.updateUser(this.userToAdd).then(user => {
        // console.log(user)
        this.$store.commit('saveLoading', false)
        if (!this.userToAdd.id) {
          this.users.push(user)
        }
        this.$alert(this.getGoodMessage(user), this.$t('success'), 'success')
      }).catch((error) => {
        console.log(error)
        this.$store.commit('saveLoading', false)
        this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
      })
      this.resetUser()
    },
    checkUser () {
      if (this.userToAdd.mail !== null && this.userToAdd.mail !== '' && this.userToAdd.pw !== null && this.userToAdd.pw !== '') {
        const roleObjectToAdd = []
        this.userToAdd.rolesStr.forEach(roleStr => {
          roleObjectToAdd.push(this.getRoleObjectFromRoleStr(roleStr))
        })
        this.userToAdd.roles = roleObjectToAdd
        this.$store.commit('saveLoading', true)
        return 'OK'
      } else {
        this.$alert(this.$t('empty-field'), this.$t('warning'), 'warning')
        return 'KO'
      }
    },
    goodFormat (roles) {
      const res = []
      roles.forEach(role => {
        res.push(role.libelle)
      })
      return res
    }
  },
  computed: {
    customColorStyle () {
      return custom.customColorStyle()
    },
    getAllUsersWithoutCurrent () {
      return this.users.filter(user => user.mail !== this.$store.state.email)
    },
    customBgColor () {
      return custom.customBgColor()
    }
  },
  created () {
    this.$store.commit('saveLoading', true)
    APIRole.getAllRole().then(roles => {
      this.optionsRoles = this.goodFormat(roles)
      this.roles = roles
    })
    APIUser.getAllUser().then(users => {
      users.forEach(user => {
        var userTemp = user
        userTemp.rolesStr = this.goodFormat(userTemp.roles)
        this.users.push(userTemp)
        if (user.mail === this.$store.state.email) {
          this.mainUser = userTemp
        }
      })
      this.$store.commit('saveLoading', false)
    })
  },
  mounted () {
    custom.getGoodItemAndColorIt(this.$route.path)
  }
}
</script>

<style src="vue-multiselect/dist/vue-multiselect.min.css"></style>

<style scoped>
.center {
  margin-top: 25px;
  text-align: center;
}
.btn-outline-secondary {
  margin-left: 15px;
}
.form {
  max-width: 50%;
  margin: 30px 7% 25px 25%;
  border-radius: 15px;
  padding: 20px;
}
span {
  margin-left: 5px;
  font-size: 13px;
  font-style: italic;
}
</style>
